 src/backend/utils/sort/gen_qsort_tuple.pl | 62 ++++++++++++++++++++++++++++---
 1 file changed, 57 insertions(+), 5 deletions(-)

diff --git a/src/backend/utils/sort/gen_qsort_tuple.pl b/src/backend/utils/sort/gen_qsort_tuple.pl
index 6186d0a..7d751b7 100644
--- a/src/backend/utils/sort/gen_qsort_tuple.pl
+++ b/src/backend/utils/sort/gen_qsort_tuple.pl
@@ -162,12 +162,64 @@ qsort_$SUFFIX(SortTuple *a, size_t n$EXTRAARGS)
 
 loop:
 	CHECK_FOR_INTERRUPTS();
-	if (n < 7)
-	{
-		for (pm = a + 1; pm < a + n; pm++)
-			for (pl = pm; pl > a && cmp_$SUFFIX(pl - 1, pl$CMPPARAMS) > 0; pl--)
-				swap(pl, pl - 1);
+	if (n <= 8) {
+		#define swapif(l,r) if (cmp_$SUFFIX(a+l,a+r$CMPPARAMS) > 0) swap(a+l,a+r)
+		switch(n) {
+			case 0: 
+			case 1:
+			break;
+
+			case 2:
+			swapif(0,1);
+			break;
+
+			case 3:
+			swapif(0,1); swapif(1,2);
+			swapif(0,1);
+			break;
+
+			case 4:
+			swapif(0,1); swapif(2,3);
+			swapif(1,3); swapif(0,2);
+			swapif(1,2);
+			break;
+
+			case 5:
+			swapif(1,2); swapif(3,4);
+			swapif(1,3); swapif(0,2);
+			swapif(2,4); swapif(0,3);
+			swapif(0,1); swapif(2,3);
+			swapif(1,2);
+			break;
+
+			case 6:
+			swapif(0,1); swapif(2,3); swapif(4,5);
+			swapif(0,2); swapif(3,5); swapif(1,4);
+			swapif(0,1); swapif(2,3); swapif(4,5);
+			swapif(1,2); swapif(3,4);
+			swapif(2,3);
+			break;
+
+			case 7:
+			swapif(1,2); swapif(3,4); swapif(5,6);
+			swapif(0,2); swapif(4,6); swapif(3,5);
+			swapif(2,6); swapif(1,5); swapif(0,4);
+			swapif(2,5); swapif(0,3);
+			swapif(2,4); swapif(1,3);
+			swapif(0,1); swapif(2,3); swapif(4,5);
+			break;
+
+			case 8:
+			swapif(0, 1); swapif(2, 3); swapif(4, 5); swapif(6, 7);
+			swapif(0, 3); swapif(1, 2); swapif(4, 7); swapif(5, 6);
+			swapif(0, 1); swapif(2, 3); swapif(4, 5); swapif(6, 7);
+			swapif(0, 7); swapif(1, 6); swapif(2, 5); swapif(3, 4);
+			swapif(1, 3); swapif(0, 2); swapif(5, 7); swapif(4, 6);
+			swapif(0, 1); swapif(2, 3); swapif(4, 5); swapif(6, 7);
+			break;
+		}
 		return;
+		#undef swapif
 	}
 	presorted = 1;
 	for (pm = a + 1; pm < a + n; pm++)
-- 
2.6.2

